=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2005-08-25 05:58:05 +0000
+++ bzrlib/check.py	2005-08-26 01:15:18 +0000
@@ -83,7 +83,7 @@
     TODO: Check for extra files in the control directory.
     """
     from bzrlib.trace import mutter
-    from bzrlib.errors import BzrCheckError
+    from bzrlib.errors import BzrCheckError, NoSuchRevision
     from bzrlib.osutils import fingerprint_file
     from bzrlib.inventory import ROOT_ID
     from bzrlib.branch import gen_root_id
@@ -95,6 +95,7 @@
 
         missing_inventory_sha_cnt = 0
         missing_revision_sha_cnt = 0
+        missing_revision_cnt = 0
 
         history = branch.revision_history()
         revno = 0
@@ -134,7 +135,15 @@
                         missing_revision_sha_cnt += 1
                         continue
                     prid = prr.revision_id
-                    actual_sha = branch.get_revision_sha1(prid)
+                    
+                    try:
+                        actual_sha = branch.get_revision_sha1(prid)
+                    except NoSuchRevision:
+                        missing_revision_cnt += 1
+                        mutter("parent {%s} of {%s} not present in store",
+                               prid, rev_id)
+                        continue
+                        
                     if prr.revision_sha1 != actual_sha:
                         raise BzrCheckError("mismatched revision sha1 for "
                                             "parent {%s} of {%s}: %s vs %s"
@@ -226,6 +235,9 @@
     if missing_revision_sha_cnt:
         print '%d parent links are missing revision_sha1' % missing_revision_sha_cnt
 
+    if missing_revision_cnt:
+        print '%d revisions are mentioned but not present' % missing_revision_cnt
+
     # stub this out for now because the main bzr branch has references
     # to revisions that aren't present in the store -- mbp 20050804
 #    if (missing_inventory_sha_cnt

